#!/bin/bash
#
# Copyright (c)2016-2017 System Fabric Works, Inc. All Rights Reserved.
#
# Update the HFI1 eprom 
#
set -e

HFIE=/usr/bin/hfi1_eprom
OROM=HfiPcieGen3Loader_1.5.2.0.0.rom
BFILE=HfiPcieGen3_1.5.2.0.0.efi
CONFIG=hfi1_platform.dat

if [ -f /etc/redhat-release ] ; then
	FIRMWARE_HOME=/lib/firmware/updates
	OPA_BIOS_HOME=/opt/opa/bios_images
elif [ -f /etc/debian_version ] ; then
	FIRMWARE_HOME=/lib/firmware
	OPA_BIOS_HOME=/usr/share/hfi1-uefi/bios_images
else
	echo "ERROR: Redhat or Debian not detected."
	exit 1
fi

CONFIG=$FIRMWARE_HOME/$CONFIG

if [ ! -f $CONFIG ] ; then
	echo "Configuration $CONFIG does not exist"
	exit 1
fi

if [ ! -f $OPA_BIOS_HOME/$OROM ] ; then
	echo "Option ROM $OROM does not exist"
	exit 1
fi

if [ ! -f $OPA_BIOS_HOME/$BFILE ] ; then
	echo "Bulk file $BFILE does not exist"
	exit 1
fi
set -x
$HFIE -w -c $CONFIG
$HFIE -w -o $OPA_BIOS_HOME/$OROM
$HFIE -w -b $OPA_BIOS_HOME/$BFILE


